Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/APP12.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/APP12.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/APP12.pm	(revision 34921)
@@ -13,7 +13,7 @@
 use strict;
 use vars qw($VERSION);
-use Image::ExifTool qw(:DataAccess);
-
-$VERSION = '1.08';
+use Image::ExifTool qw(:DataAccess :Utils);
+
+$VERSION = '1.13';
 
 sub ProcessAPP12($$$);
@@ -25,4 +25,5 @@
     PROCESS_PROC => \&ProcessAPP12,
     GROUPS => { 0 => 'APP12', 1 => 'PictureInfo', 2 => 'Image' },
+    PRIORITY => 0,
     NOTES => q{
         The JPEG APP12 "Picture Info" segment was used by some older cameras, and
@@ -134,9 +135,9 @@
 sub WriteDucky($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
-    $exifTool or return 1;    # allow dummy access to autoload this package
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    $et or return 1;    # allow dummy access to autoload this package
     my $dataPt = $$dirInfo{DataPt};
     my $pos = $$dirInfo{DirStart};
-    my $newTags = $exifTool->GetNewTagInfoHash($tagTablePtr);
+    my $newTags = $et->GetNewTagInfoHash($tagTablePtr);
     my @addTags = sort { $a <=> $b } keys(%$newTags);
     my ($dirEnd, %doneTags);
@@ -158,5 +159,5 @@
             $pos += 4;
             if ($pos + $len > $dirEnd) {
-                $exifTool->Warn('Invalid Ducky block length');
+                $et->Warn('Invalid Ducky block length');
                 return undef;
             }
@@ -171,20 +172,20 @@
         my $tagInfo = $$newTags{$tag};
         if ($tagInfo) {
-            my $nvHash = $exifTool->GetNewValueHash($tagInfo);
+            my $nvHash = $et->GetNewValueHash($tagInfo);
             my $isNew;
             if (defined $val) {
-                if (Image::ExifTool::IsOverwriting($nvHash, $val)) {
-                    $exifTool->VerboseValue("- Ducky:$$tagInfo{Name}", $val);
+                if ($et->IsOverwriting($nvHash, $val)) {
+                    $et->VerboseValue("- Ducky:$$tagInfo{Name}", $val);
                     $isNew = 1;
                 }
             } else {
-                next unless Image::ExifTool::IsCreating($nvHash);
+                next unless $$nvHash{IsCreating};
                 $isNew = 1;
             }
             if ($isNew) {
-                $val = Image::ExifTool::GetNewValues($nvHash);
-                ++$exifTool->{CHANGED};
+                $val = $et->GetNewValue($nvHash);
+                ++$$et{CHANGED};
                 next unless defined $val;   # next if tag is being deleted
-                $exifTool->VerboseValue("+ Ducky:$$tagInfo{Name}", $val);
+                $et->VerboseValue("+ Ducky:$$tagInfo{Name}", $val);
             }
         }
@@ -207,5 +208,5 @@
 sub ProcessDucky($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $pos = $$dirInfo{DirStart};
@@ -219,9 +220,9 @@
         $pos += 4;
         if ($pos + $len > $dirEnd) {
-            $exifTool->Warn('Invalid Ducky block length');
+            $et->Warn('Invalid Ducky block length');
             last;
         }
         my $val = substr($$dataPt, $pos, $len);
-        $exifTool->HandleTag($tagTablePtr, $tag, $val,
+        $et->HandleTag($tagTablePtr, $tag, $val,
             DataPt => $dataPt,
             DataPos => $$dirInfo{DataPos},
@@ -240,5 +241,5 @@
 sub ProcessAPP12($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dirStart = $$dirInfo{DirStart} || 0;
@@ -250,5 +251,5 @@
         pos($$dataPt) = $$dirInfo{DirStart};
     }
-    my $verbose = $exifTool->Options('Verbose');
+    my $verbose = $et->Options('Verbose');
     my $success = 0;
     my $section = '';
@@ -256,5 +257,5 @@
 
     # this regular expression is a bit complex, but basically we are looking for
-    # section headers (ie. "[Camera Info]") and tag/value pairs (ie. "tag=value",
+    # section headers (eg. "[Camera Info]") and tag/value pairs (eg. "tag=value",
     # where "value" may contain white space), separated by spaces or CR/LF.
     # (APP12 uses CR/LF, but Olympus TextualInfo is similar and uses spaces)
@@ -263,14 +264,14 @@
         # was this a section name?
         if ($token =~ /^\[(.*)\]/) {
-            $exifTool->VerboseDir($1) if $verbose;
+            $et->VerboseDir($1) if $verbose;
             $section = ($token =~ /\[(\S+) ?Info\]/i) ? $1 : '';
             $success = 1;
             next;
         }
-        $exifTool->VerboseDir($$dirInfo{DirName}) if $verbose and not $success;
+        $et->VerboseDir($$dirInfo{DirName}) if $verbose and not $success;
         $success = 1;
         my ($tag, $val) = ($token =~ /(\S+)=(.+)/);
-        my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tag);
-        $verbose and $exifTool->VerboseInfo($tag, $tagInfo, Value => $val);
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $tag);
+        $verbose and $et->VerboseInfo($tag, $tagInfo, Value => $val);
         unless ($tagInfo) {
             # add new tag to table
@@ -278,7 +279,7 @@
             # put in Camera group if information in "Camera" section
             $$tagInfo{Groups} = { 2 => 'Camera' } if $section =~ /camera/i;
-            Image::ExifTool::AddTagToTable($tagTablePtr, $tag, $tagInfo);
-        }
-        $exifTool->FoundTag($tagInfo, $val);
+            AddTagToTable($tagTablePtr, $tag, $tagInfo);
+        }
+        $et->FoundTag($tagInfo, $val);
     }
     return $success;
@@ -305,5 +306,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/ASF.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/ASF.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/ASF.pm	(revision 34921)
@@ -18,8 +18,10 @@
 use Image::ExifTool::RIFF;
 
-$VERSION = '1.17';
-
+$VERSION = '1.25';
+
+sub ProcessASF($$;$);
+sub ProcessContentDescription($$$);
+sub ProcessExtendedContentDescription($$$);
 sub ProcessMetadata($$$);
-sub ProcessContentDescription($$$);
 sub ProcessPicture($$$);
 sub ProcessCodecList($$$);
@@ -63,5 +65,5 @@
 # ASF top level objects
 %Image::ExifTool::ASF::Main = (
-    PROCESS_PROC => \&Image::ExifTool::ASF::ProcessASF,
+    PROCESS_PROC => \&ProcessASF,
     NOTES => q{
         The ASF format is used by Windows WMA and WMV files, and DIVX videos.  Tag
@@ -86,5 +88,5 @@
 # ASF header objects
 %Image::ExifTool::ASF::Header = (
-    PROCESS_PROC => \&Image::ExifTool::ASF::ProcessASF,
+    PROCESS_PROC => \&ProcessASF,
     '8CABDCA1-A947-11CF-8EE4-00C00C205365' => {
         Name => 'FileProperties',
@@ -130,5 +132,5 @@
     GROUPS => { 2 => 'Video' },
     0 => 'Title',
-    1 => { Name => 'Author', Groups => { 2 => 'Author' } },
+    1 => { Name => 'Author',    Groups => { 2 => 'Author' } },
     2 => { Name => 'Copyright', Groups => { 2 => 'Author' } },
     3 => 'Description',
@@ -148,9 +150,12 @@
         },
     },
-    1 => { Name => 'BannerImage', Binary => 1 },
+    1 => { Name => 'BannerImage', Groups => { 2 => 'Preview' }, Binary => 1 },
     2 => 'BannerImageURL',
     3 => 'CopyrightURL',
 );
 
+# Note: Many of these tags are similar to those in Image::ExifTool::Microsoft::Xtra
+#       and Image::ExifTool::WTV::Metadata
+# (tags in this table may have a leading "WM/" removed)
 %Image::ExifTool::ASF::ExtendedDescr = (
     PROCESS_PROC => \&ProcessExtendedContentDescription,
@@ -237,5 +242,5 @@
     EncodedBy => {},
     EncodingSettings => {},
-    EncodingTime => { Groups => { 2 => 'Time' } },
+    EncodingTime => { Groups => { 2 => 'Time' }, PrintConv => '$self->ConvertDateTime($val)' },
     Genre => {},
     GenreID => {},
@@ -246,6 +251,6 @@
     Lyrics_Synchronised => {},
     MCDI => {},
-    MediaClassPrimaryID => {},
-    MediaClassSecondaryID => {},
+    MediaClassPrimaryID => { ValueConv => 'Image::ExifTool::ASF::GetGUID($val)' },
+    MediaClassSecondaryID => { ValueConv => 'Image::ExifTool::ASF::GetGUID($val)' },
     MediaCredits => {},
     MediaIsDelay => {},
@@ -259,5 +264,9 @@
     MediaIsTape => {},
     MediaNetworkAffiliation => {},
-    MediaOriginalBroadcastDateTime => { Groups => { 2 => 'Time' } },
+    MediaOriginalBroadcastDateTime => {
+        Groups => { 2 => 'Time' },
+        ValueConv => '$val=~tr/-T/: /; $val',
+        PrintConv => '$self->ConvertDateTime($val)',
+    },
     MediaOriginalChannel => {},
     MediaStationCallSign => {},
@@ -267,7 +276,11 @@
     OriginalAlbumTitle => {},
     OriginalArtist => {},
-    OriginalFilename => {},
+    OriginalFilename => 'OriginalFileName',
     OriginalLyricist => {},
-    OriginalReleaseTime => { Groups => { 2 => 'Time' } },
+    OriginalReleaseTime => {
+        Groups => { 2 => 'Time' },
+        ValueConv => '$val=~tr/-T/: /; $val',
+        PrintConv => '$self->ConvertDateTime($val)',
+    },
     OriginalReleaseYear => { Groups => { 2 => 'Time' } },
     ParentalRating => {},
@@ -295,6 +308,6 @@
     StreamTypeInfo => {},
     SubscriptionContentID => {},
-    SubTitle => {},
-    SubTitleDescription => {},
+    SubTitle            => 'Subtitle',
+    SubTitleDescription => 'SubtitleDescription',
     Text => {},
     ToolName => {},
@@ -316,5 +329,5 @@
     WMContentID => {},
     Writer => { Groups => { 2 => 'Author' } },
-    Year => { Groups => { 2 => 'Time' } },
+    Year   => { Groups => { 2 => 'Time' } },
 );
 
@@ -348,8 +361,9 @@
         },
     },
-    1 => 'PictureMimeType',
+    1 => 'PictureMIMEType',
     2 => 'PictureDescription',
     3 => {
         Name => 'Picture',
+        Groups => { 2 => 'Preview' },
         Binary => 1,
     },
@@ -373,10 +387,13 @@
             my $t = $val / 1e7 - (((1970-1601)*365+89)*24*3600);
             return Image::ExifTool::ConvertUnixTime($t) . 'Z';
-        }
+        },
+        PrintConv => '$self->ConvertDateTime($val)',
     },
     32 => { Name => 'DataPackets',  Format => 'int64u' },
     40 => {
-        Name => 'PlayDuration',
+        Name => 'Duration',
         Format => 'int64u',
+        Notes => 'called PlayDuration by the ASF spec',
+        Priority => 0,
         ValueConv => '$val / 1e7',
         PrintConv => 'ConvertDuration($val)',
@@ -403,6 +420,6 @@
         Format => 'binary[16]',
         RawConv => sub { # set ASF_STREAM_TYPE for use in conditional tags
-            my ($val, $exifTool) = @_;
-            $exifTool->{ASF_STREAM_TYPE} = $streamType{GetGUID($val)} || '';
+            my ($val, $et) = @_;
+            $$et{ASF_STREAM_TYPE} = $streamType{GetGUID($val)} || '';
             return $val;
         },
@@ -462,5 +479,5 @@
 
 %Image::ExifTool::ASF::HeaderExtension = (
-    PROCESS_PROC => \&Image::ExifTool::ASF::ProcessASF,
+    PROCESS_PROC => \&ProcessASF,
     '14E6A5CB-C672-4332-8399-A96952065B5A' => 'ExtendedStreamProps',
     'A08649CF-4775-4670-8A16-6E35357566CD' => 'AdvancedMutualExcl',
@@ -471,9 +488,17 @@
     'C5F8CBEA-5BAF-4877-8467-AA8C44FA4CCA' => {
         Name => 'Metadata',
-        SubDirectory => { TagTable => 'Image::ExifTool::ASF::Metadata' },
+        SubDirectory => {
+            # have seen some tags same as ExtendedDescr, so use this table - PH
+            TagTable => 'Image::ExifTool::ASF::ExtendedDescr',
+            ProcessProc => \&ProcessMetadata,
+        },
     },
     '44231C94-9498-49D1-A141-1D134E457054' => {
         Name => 'MetadataLibrary',
-        SubDirectory => { TagTable => 'Image::ExifTool::ASF::Metadata' },
+        SubDirectory => {
+            # have seen some tags same as ExtendedDescr, so use this table - PH
+            TagTable => 'Image::ExifTool::ASF::ExtendedDescr',
+            ProcessProc => \&ProcessMetadata,
+        },
     },
     'D6E229DF-35DA-11D1-9034-00A0C90349BE' => 'IndexParameters',
@@ -482,8 +507,4 @@
     '43058533-6981-49E6-9B74-AD12CB86D58C' => 'AdvancedContentEncryption',
     'ABD3D211-A9BA-11cf-8EE6-00C00C205365' => 'Reserved1',
-);
-
-%Image::ExifTool::ASF::Metadata = (
-    PROCESS_PROC => \&Image::ExifTool::ASF::ProcessMetadata,
 );
 
@@ -505,5 +526,7 @@
 {
     # must do some byte swapping
-    my $buff = unpack('H*',pack('NnnNN',unpack('VvvNN',$_[0])));
+    my $val = shift;
+    return $val unless length($val) == 16;
+    my $buff = unpack('H*',pack('NnnNN',unpack('VvvNN',$val)));
     $buff =~ s/(.{8})(.{4})(.{4})(.{4})/$1-$2-$3-$4-/;
     return uc($buff);
@@ -516,5 +539,5 @@
 sub ProcessContentDescription($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dirLen = $$dirInfo{DirLen};
@@ -527,6 +550,6 @@
         next unless $len;
         return 0 if $pos + $len > $dirLen;
-        my $val = $exifTool->Decode(substr($$dataPt,$pos,$len),'UCS2','II');
-        $exifTool->HandleTag($tagTablePtr, $tag, $val);
+        my $val = $et->Decode(substr($$dataPt,$pos,$len),'UCS2','II');
+        $et->HandleTag($tagTablePtr, $tag, $val);
         $pos += $len;
     }
@@ -540,10 +563,10 @@
 sub ProcessContentBranding($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dirLen = $$dirInfo{DirLen};
     return 0 if $dirLen < 40;
     # decode banner image type
-    $exifTool->HandleTag($tagTablePtr, 0, unpack('V', $$dataPt));
+    $et->HandleTag($tagTablePtr, 0, unpack('V', $$dataPt));
     # decode banner image, banner URL and copyright URL
     my $pos = 4;
@@ -556,5 +579,5 @@
         return 0 if $pos + $size > $dirLen;
         my $val = substr($$dataPt, $pos, $size);
-        $exifTool->HandleTag($tagTablePtr, $tag, $val);
+        $et->HandleTag($tagTablePtr, $tag, $val);
         $pos += $size;
     }
@@ -569,8 +592,8 @@
 sub ReadASF($$$$$)
 {
-    my ($exifTool, $dataPt, $pos, $format, $size) = @_;
+    my ($et, $dataPt, $pos, $format, $size) = @_;
     my @vals;
     if ($format == 0) { # unicode string
-        $vals[0] = $exifTool->Decode(substr($$dataPt,$pos,$size),'UCS2','II');
+        $vals[0] = $et->Decode(substr($$dataPt,$pos,$size),'UCS2','II');
     } elsif ($format == 2) { # 4-byte boolean
         @vals = ReadValue($dataPt, $pos, 'int32u', undef, $size);
@@ -596,10 +619,10 @@
 sub ProcessExtendedContentDescription($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dirLen = $$dirInfo{DirLen};
     return 0 if $dirLen < 2;
     my $count = Get16u($dataPt, 0);
-    $exifTool->VerboseDir($dirInfo, $count);
+    $et->VerboseDir($dirInfo, $count);
     my $pos = 2;
     my $i;
@@ -613,11 +636,46 @@
         $pos += $nameLen;
         my ($dType, $dLen) = unpack("x${pos}v2", $$dataPt);
-        my $val = ReadASF($exifTool,$dataPt,$pos+4,$dType,$dLen);
-        $exifTool->HandleTag($tagTablePtr, $tag, $val,
+        $pos += 4;
+        return 0 if $pos + $dLen > $dirLen;
+        my $val = ReadASF($et,$dataPt,$pos,$dType,$dLen);
+        $et->HandleTag($tagTablePtr, $tag, $val,
             DataPt => $dataPt,
-            Start  => $pos + 4,
+            Start  => $pos,
             Size   => $dLen,
         );
-        $pos += 4 + $dLen;
+        $pos += $dLen;
+    }
+    return 1;
+}
+
+#------------------------------------------------------------------------------
+# Process ASF metadata library (similar to ProcessExtendedContentDescription above)
+# Inputs: 0) ExifTool object reference, 1) dirInfo ref, 2) tag table reference
+# Returns: 1 on success
+sub ProcessMetadata($$$)
+{
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    my $dataPt = $$dirInfo{DataPt};
+    my $dirLen = $$dirInfo{DirLen};
+    return 0 if $dirLen < 2;
+    my $count = Get16u($dataPt, 0);
+    $et->VerboseDir($dirInfo, $count);
+    my $pos = 2;
+    my $i;
+    for ($i=0; $i<$count; ++$i) {
+        return 0 if $pos + 12 > $dirLen;
+        my ($index, $stream, $nameLen, $dType, $dLen) = unpack("x${pos}v4V", $$dataPt);
+        $pos += 12;
+        return 0 if $pos + $nameLen + $dLen > $dirLen;
+        my $tag = Image::ExifTool::Decode(undef,substr($$dataPt,$pos,$nameLen),'UCS2','II','Latin');
+        $tag =~ s/^WM\///; # remove leading "WM/"
+        $pos += $nameLen;
+        my $val = ReadASF($et,$dataPt,$pos,$dType,$dLen);
+        $et->HandleTag($tagTablePtr, $tag, $val,
+            DataPt => $dataPt,
+            Start  => $pos,
+            Size   => $dLen,
+        );
+        $pos += $dLen;
     }
     return 1;
@@ -630,5 +688,5 @@
 sub ProcessPicture($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dirStart = $$dirInfo{DirStart};
@@ -637,15 +695,16 @@
     # extract picture type and length
     my ($type, $picLen) = unpack("x${dirStart}CV", $$dataPt);
-    $exifTool->HandleTag($tagTablePtr, 0, $type);
+    $et->VerboseDir('Picture');
+    $et->HandleTag($tagTablePtr, 0, $type);
     # extract mime type and description strings (null-terminated unicode strings)
     my $n = $dirLen - 5 - $picLen;
     return 0 if $n & 0x01 or $n < 4;
     my $str = substr($$dataPt, $dirStart+5, $n);
-    if ($str =~ /^((?:..)*?)\0\0((?:..)*?)\0\0/) {
+    if ($str =~ /^((?:..)*?)\0\0((?:..)*?)\0\0/s) {
         my ($mime, $desc) = ($1, $2);
-        $exifTool->HandleTag($tagTablePtr, 1, $exifTool->Decode($mime,'UCS2','II'));
-        $exifTool->HandleTag($tagTablePtr, 2, $exifTool->Decode($desc,'UCS2','II')) if length $desc;
+        $et->HandleTag($tagTablePtr, 1, $et->Decode($mime,'UCS2','II'));
+        $et->HandleTag($tagTablePtr, 2, $et->Decode($desc,'UCS2','II')) if length $desc;
     }
-    $exifTool->HandleTag($tagTablePtr, 3, substr($$dataPt, $dirStart+5+$n, $picLen));
+    $et->HandleTag($tagTablePtr, 3, substr($$dataPt, $dirStart+5+$n, $picLen));
     return 1;
 }
@@ -657,10 +716,10 @@
 sub ProcessCodecList($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dirLen = $$dirInfo{DirLen};
     return 0 if $dirLen < 20;
     my $count = Get32u($dataPt, 16);
-    $exifTool->VerboseDir($dirInfo, $count);
+    $et->VerboseDir($dirInfo, $count);
     my $pos = 20;
     my $i;
@@ -673,11 +732,11 @@
         $pos += 4;
         return 0 if $pos + $nameLen + 2 > $dirLen;
-        my $name = $exifTool->Decode(substr($$dataPt,$pos,$nameLen),'UCS2','II');
-        $exifTool->HandleTag($tagTablePtr, "${type}Name", $name);
+        my $name = $et->Decode(substr($$dataPt,$pos,$nameLen),'UCS2','II');
+        $et->HandleTag($tagTablePtr, "${type}Name", $name);
         my $descLen = Get16u($dataPt, $pos + $nameLen) * 2;
         $pos += $nameLen + 2;
         return 0 if $pos + $descLen + 2 > $dirLen;
-        my $desc = $exifTool->Decode(substr($$dataPt,$pos,$descLen),'UCS2','II');
-        $exifTool->HandleTag($tagTablePtr, "${type}Description", $desc);
+        my $desc = $et->Decode(substr($$dataPt,$pos,$descLen),'UCS2','II');
+        $et->HandleTag($tagTablePtr, "${type}Description", $desc);
         my $infoLen = Get16u($dataPt, $pos + $descLen);
         $pos += $descLen + 2 + $infoLen;
@@ -687,35 +746,4 @@
 
 #------------------------------------------------------------------------------
-# Process ASF metadata library
-# Inputs: 0) ExifTool object reference, 1) dirInfo ref, 2) tag table reference
-# Returns: 1 on success
-sub ProcessMetadata($$$)
-{
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
-    my $dataPt = $$dirInfo{DataPt};
-    my $dirLen = $$dirInfo{DirLen};
-    return 0 if $dirLen < 2;
-    my $count = Get16u($dataPt, 0);
-    $exifTool->VerboseDir($dirInfo, $count);
-    my $pos = 2;
-    my $i;
-    for ($i=0; $i<$count; ++$i) {
-        return 0 if $pos + 12 > $dirLen;
-        my ($index, $stream, $nameLen, $dType, $dLen) = unpack("x${pos}v4V", $$dataPt);
-        $pos += 12;
-        return 0 if $pos + $nameLen + $dLen > $dirLen;
-        my $tag = Image::ExifTool::Decode(undef,substr($$dataPt,$pos,$nameLen),'UCS2','II','Latin');
-        my $val = ReadASF($exifTool,$dataPt,$pos+$nameLen,$dType,$dLen);
-        $exifTool->HandleTag($tagTablePtr, $tag, $val,
-            DataPt => $dataPt,
-            Start  => $pos,
-            Size   => $dLen,
-        );
-        $pos += $nameLen + $dLen;
-    }
-    return 1;
-}
-
-#------------------------------------------------------------------------------
 # Extract information from a ASF file
 # Inputs: 0) ExifTool object reference, 1) dirInfo reference, 2) tag table ref
@@ -723,7 +751,7 @@
 sub ProcessASF($$;$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $raf = $$dirInfo{RAF};
-    my $verbose = $exifTool->Options('Verbose');
+    my $verbose = $et->Options('Verbose');
     my $rtnVal = 0;
     my $pos = 0;
@@ -733,11 +761,11 @@
         last unless $raf->Read($buff, 24) == 24;
         $pos += 24;
-        my $tag = GetGUID($buff);
+        my $tag = GetGUID(substr($buff,0,16));
         unless ($tagTablePtr) {
             # verify this is a valid ASF file
             last unless $tag eq '75B22630-668E-11CF-A6D9-00AA0062CE6C';
-            my $fileType = $exifTool->{FILE_EXT};
+            my $fileType = $$et{FILE_EXT};
             $fileType = 'ASF' unless $fileType and $fileType =~ /^(ASF|WMV|WMA|DIVX)$/;
-            $exifTool->SetFileType($fileType);
+            $et->SetFileType($fileType);
             SetByteOrder('II');
             $tagTablePtr = GetTagTable('Image::ExifTool::ASF::Main');
@@ -752,7 +780,7 @@
             if ($size > 0x7fffffff * 4294967296) {
                 $err = 'Invalid ASF object size';
-            } elsif ($exifTool->Options('LargeFileSupport')) {
+            } elsif ($et->Options('LargeFileSupport')) {
                 if ($raf->Seek($size, 1)) {
-                    $exifTool->VPrint(0, "  Skipped large ASF object ($size bytes)\n");
+                    $et->VPrint(0, "  Skipped large ASF object ($size bytes)\n");
                     $pos += $size;
                     next;
@@ -768,8 +796,8 @@
             pop @childEnd;
             $tagTablePtr = pop @parentTable;
-            $exifTool->{INDENT} = substr($exifTool->{INDENT},0,-2);
+            $$et{INDENT} = substr($$et{INDENT},0,-2);
         }
-        my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tag);
-        $verbose and $exifTool->VerboseInfo($tag, $tagInfo);
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $tag);
+        $verbose and $et->VerboseInfo($tag, $tagInfo);
         if ($tagInfo) {
             my $subdir = $$tagInfo{SubDirectory};
@@ -781,5 +809,5 @@
                         if ($verbose > 2) {
                             $raf->Read($buff, $s) == $s or $err = 'Truncated file', last;
-                            $exifTool->VerboseDump(\$buff);
+                            $et->VerboseDump(\$buff);
                         } elsif (not $raf->Seek($s, 1)) {
                             $err = 'Seek error';
@@ -792,6 +820,6 @@
                         $pos += $$subdir{Size};
                         if ($verbose) {
-                            $exifTool->{INDENT} .= '| ';
-                            $exifTool->VerboseDir($$tagInfo{Name});
+                            $$et{INDENT} .= '| ';
+                            $et->VerboseDir($$tagInfo{Name});
                         }
                         next;
@@ -804,7 +832,7 @@
                         DirName => $$tagInfo{Name},
                     );
-                    $exifTool->VerboseDump(\$buff) if $verbose > 2;
-                    unless ($exifTool->ProcessDirectory(\%subdirInfo, $subTable)) {
-                        $exifTool->Warn("Error processing $$tagInfo{Name} directory");
+                    $et->VerboseDump(\$buff) if $verbose > 2;
+                    unless ($et->ProcessDirectory(\%subdirInfo, $subTable, $$subdir{ProcessProc})) {
+                        $et->Warn("Error processing $$tagInfo{Name} directory");
                     }
                     $pos += $size;
@@ -818,5 +846,5 @@
         if ($verbose > 2) {
             $raf->Read($buff, $size) == $size or $err = 'Truncated file', last;
-            $exifTool->VerboseDump(\$buff);
+            $et->VerboseDump(\$buff);
         } elsif (not $raf->Seek($size, 1)) { # skip the block
             $err = 'Seek error';
@@ -825,5 +853,5 @@
         $pos += $size;
     }
-    $err and $exifTool->Warn($err);
+    $err and $et->Warn($err);
     return $rtnVal;
 }
@@ -849,5 +877,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Apple.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Apple.pm	(revision 34921)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Apple.pm	(revision 34921)
@@ -0,0 +1,162 @@
+#------------------------------------------------------------------------------
+# File:         Apple.pm
+#
+# Description:  Apple EXIF maker notes tags
+#
+# Revisions:    2013-09-13 - P. Harvey Created
+#
+# References:   1) http://www.photoinvestigator.co/blog/the-mystery-of-maker-apple-metadata/
+#------------------------------------------------------------------------------
+
+package Image::ExifTool::Apple;
+
+use strict;
+use vars qw($VERSION);
+use Image::ExifTool::Exif;
+use Image::ExifTool::PLIST;
+
+$VERSION = '1.05';
+
+# Apple iPhone metadata (ref PH)
+%Image::ExifTool::Apple::Main = (
+    WRITE_PROC => \&Image::ExifTool::Exif::WriteExif,
+    CHECK_PROC => \&Image::ExifTool::Exif::CheckExif,
+    WRITABLE => 1,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Image' },
+    NOTES => 'Tags extracted from the maker notes of iPhone images.',
+    # 0x0001 - int32s: seen 0,1,2,3,4,9
+    # 0x0002 - binary plist with a single data object of size 512 bytes (iPhone5s)
+    0x0003 => {
+        Name => 'RunTime', # (includes time plugged in, but not when suspended, ref 1)
+        SubDirectory => { TagTable => 'Image::ExifTool::Apple::RunTime' },
+    },
+    # 0x0004 - int32s: normally 1, but 0 for low-light images
+    # 0x0005 - int32s: seen values 113-247, and 100 for blank images
+    # 0x0006 - int32s: seen values 27-258, and 20 for blank images
+    # 0x0007 - int32s: seen 1
+    0x0008 => { #1
+        Name => 'AccelerationVector',
+        Groups => { 2 => 'Camera' },
+        Writable => 'rational64s',
+        Count => 3,
+        # Note: the directions are contrary to the Apple documentation (which have the
+        # signs of all axes reversed -- apparently the Apple geeks aren't very good
+        # with basic physics, and don't understand the concept of acceleration.  See
+        # http://nscookbook.com/2013/03/ios-programming-recipe-19-using-core-motion-to-access-gyro-and-accelerometer/
+        # for one of the few correct descriptions of this).  Note that this leads to
+        # a left-handed coordinate system for acceleration.
+        Notes => q{
+            XYZ coordinates of the acceleration vector in units of g.  As viewed from
+            the front of the phone, positive X is toward the left side, positive Y is
+            toward the bottom, and positive Z points into the face of the phone
+        },
+    },
+    # 0x0009 - int32s: seen 19,275,531,4371
+    0x000a => {
+        Name => 'HDRImageType',
+        Writable => 'int32s',
+        PrintConv => {
+            # 2 => ? (iPad mini 2)
+            3 => 'HDR Image',
+            4 => 'Original Image',
+        },
+    },
+    0x000b => {
+        Name => 'BurstUUID',
+        Writable => 'string',
+        Notes => 'unique ID for all images in a burst',
+    },
+    # 0x000c - rational64s[2]: eg) "0.1640625 0.19921875"
+    # 0x000d - int32s: 0,1,6,20,24,32,40
+    # 0x000e - int32s: 0,1,4,12 (Orientation? 0=landscape? 4=portrait? ref 1)
+    # 0x000f - int32s: 2,3
+    # 0x0010 - int32s: 1
+    0x0011 => {
+        Name => 'MediaGroupUUID', #NealKrawetz private communication
+        # (changed in 12.19 from Name => 'ContentIdentifier', #forum8750)
+        Writable => 'string',
+    },
+    # 0x0014 - int32s: 1,2,3,4,5 (iPhone 6s, iOS 6.1)
+    0x0015 => {
+        Name => 'ImageUniqueID',
+        Writable => 'string',
+    },
+    # 0x0016 - string[29]: "AXZ6pMTOh2L+acSh4Kg630XCScoO\0"
+    # 0x0017 - int32s: 0,8192
+    # 0x0019 - int32s: 0,2,128
+    # 0x001a - string[6]: "q825s\0"
+    # 0x001f - int32s: 0
+);
+
+# PLIST-format CMTime structure (ref PH)
+# (CMTime ref https://developer.apple.com/library/ios/documentation/CoreMedia/Reference/CMTime/Reference/reference.html)
+%Image::ExifTool::Apple::RunTime = (
+    PROCESS_PROC => \&Image::ExifTool::PLIST::ProcessBinaryPLIST,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Image' },
+    NOTES => q{
+        This PLIST-format information contains the elements of a CMTime structure
+        representing the amount of time the phone has been running since the last
+        boot, not including standby time.
+    },
+    timescale => { Name => 'RunTimeScale' }, # (seen 1000000000 --> ns)
+    epoch     => { Name => 'RunTimeEpoch' }, # (seen 0)
+    value     => { Name => 'RunTimeValue' }, # (should divide by RunTimeScale to get seconds)
+    flags => {
+        Name => 'RunTimeFlags',
+        PrintConv => { BITMASK => {
+            0 => 'Valid',
+            1 => 'Has been rounded',
+            2 => 'Positive infinity',
+            3 => 'Negative infinity',
+            4 => 'Indefinite',
+        }},
+    },
+);
+
+# Apple composite tags
+%Image::ExifTool::Apple::Composite = (
+    GROUPS => { 2 => 'Camera' },
+    RunTimeSincePowerUp => {
+        Require => {
+            0 => 'Apple:RunTimeValue',
+            1 => 'Apple:RunTimeScale',
+        },
+        ValueConv => '$val[1] ? $val[0] / $val[1] : undef',
+        PrintConv => 'ConvertDuration($val)',
+    },
+);
+
+# add our composite tags
+Image::ExifTool::AddCompositeTags('Image::ExifTool::Apple');
+
+
+1;  # end
+
+__END__
+
+=head1 NAME
+
+Image::ExifTool::Apple - Apple EXIF maker notes tags
+
+=head1 SYNOPSIS
+
+This module is loaded automatically by Image::ExifTool when required.
+
+=head1 DESCRIPTION
+
+This module contains definitions required by Image::ExifTool to interpret
+Apple maker notes in EXIF information.
+
+=head1 AUTHOR
+
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
+
+This library is free software; you can redistribute it and/or modify it
+under the same terms as Perl itself.
+
+=head1 SEE ALSO
+
+L<Image::ExifTool::TagNames/Apple Tags>,
+L<Image::ExifTool(3pm)|Image::ExifTool>
+
+=cut
